#ifndef STATIC_CONTAINER_COMPARE_METHODS_H

#define STATIC_CONTAINER_COMPARE_METHODS_H

/*
zlib/libpng license
-------------------

Copyright (C) 2004 &o

This software is provided 'as-is', without any express or implied warranty. In n
o event will the authors be held liable for any damages arising from the use of 
this software.

Permission is granted to anyone to use this software for any purpose, including 
commercial applications, and to alter it and redistribute it freely, subject to 
the following restrictions:

The origin of this software must not be misrepresented; you must not claim that 
you wrote the original software. If you use this software in a product, an ackno
wledgment in the product documentation would be appreciated but is not required.

Altered source versions must be plainly marked as such, and must not be misrepre
sented as being the original software.
This notice may not be removed or altered from any source distribution.

project site : https://sourceforge.jp/projects/gslib/
my site : http://www.game-syokunin.com/
--------------------------------------------------------------------------------

@Iɂ́AĽ̂قLȂ̂ŁA茵ɂ͓{Qlɂ
ĂB{́Ahttp://opensource.jp/licenses/zlib-license.html 璸
Ă܂B

zlib/libpngCZX ( { )

Copyright (C) 2004 &o

{\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
Ȃ񋟂܂B{\tgEFA̎gpɂĐ邢Ȃ鑹QɂĂA
͈؂̐ӔC𕉂Ȃ̂Ƃ܂B ȉ̐ɏ]ApAvP[V
܂߂āA{\tgEFACӂ̖ړIɎgpARɉςčĔЕz邱Ƃ
Ă̐lɋ܂B

{\tgEFȀoɂċU̕\Ă͂Ȃ܂BȂIWĩ\
tgEFA쐬Ǝ咣Ă͂Ȃ܂BȂ{\tgEFA𐻕iŎgp
ꍇAi̕ɎӎĂ΍KłAK{ł͂܂B
\[XύXꍇ́ÂƂ𖾎Ȃ΂Ȃ܂BIWĩ\tgE
FAłƂU̕\Ă͂Ȃ܂B
\[X̔ЕzA̕\폜A\̓eύX肵Ă͂Ȃ܂
B 

project site : https://sourceforge.jp/projects/gslib/
my site : http://www.game-syokunin.com/
*/

#include <algorithm>
#include <boost/operators.hpp>

namespace gslib {
	namespace static_container {
		///	rZq` mixin
		template < typename SubClass >
		class compare_methods : public boost::less_than_comparable1< SubClass >, public boost::equality_comparable1< SubClass > {
		public:
			//	VC 7.1 ł͂ɂ list ܂舵ĂȂ
	/*		friend bool operator == ( const SubClass& a, const SubClass& b ) {
				return a.equal( b );
			}
			
			friend bool operator < ( const SubClass& a, const SubClass& b ) {
				return std::lexicographical_compare( a.begin(), a.end(), b.begin(), b.end() );
			}*/
			
			bool operator == ( const SubClass& other ) const {
				return equal( other );
			}
			
			bool operator < ( const SubClass& other ) const {
				return std::lexicographical_compare(
					static_cast< const SubClass* >( this )->begin(), static_cast< const SubClass* >( this )->end(),
					other.begin(), other.end() );
			}
			
			///	CӃReiƂ̔r
			template < typename OtherContainer >
			bool equal( const OtherContainer& cont ) const {
				if ( static_cast< const SubClass* >( this )->size() == cont.size() ) {
					return std::equal(
						static_cast< const SubClass* >( this )->begin(),
						static_cast< const SubClass* >( this )->end(),
						cont.begin() );
				} else {
					return false;
				}
			}
		};
	}
}

#endif
