#ifndef STATIC_CONTAINER_LIST_HASH_H

#define STATIC_CONTAINER_LIST_HASH_H

/*
zlib/libpng license
-------------------

Copyright (C) 2004 &o

This software is provided 'as-is', without any express or implied warranty. In n
o event will the authors be held liable for any damages arising from the use of 
this software.

Permission is granted to anyone to use this software for any purpose, including 
commercial applications, and to alter it and redistribute it freely, subject to 
the following restrictions:

The origin of this software must not be misrepresented; you must not claim that 
you wrote the original software. If you use this software in a product, an ackno
wledgment in the product documentation would be appreciated but is not required.

Altered source versions must be plainly marked as such, and must not be misrepre
sented as being the original software.
This notice may not be removed or altered from any source distribution.

project site : https://sourceforge.jp/projects/gslib/
my site : http://www.game-syokunin.com/
--------------------------------------------------------------------------------

@Iɂ́AĽ̂قLȂ̂ŁA茵ɂ͓{Qlɂ
ĂB{́Ahttp://opensource.jp/licenses/zlib-license.html 璸
Ă܂B

zlib/libpngCZX ( { )

Copyright (C) 2004 &o

{\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
Ȃ񋟂܂B{\tgEFA̎gpɂĐ邢Ȃ鑹QɂĂA
͈؂̐ӔC𕉂Ȃ̂Ƃ܂B ȉ̐ɏ]ApAvP[V
܂߂āA{\tgEFACӂ̖ړIɎgpARɉςčĔЕz邱Ƃ
Ă̐lɋ܂B

{\tgEFȀoɂċU̕\Ă͂Ȃ܂BȂIWĩ\
tgEFA쐬Ǝ咣Ă͂Ȃ܂BȂ{\tgEFA𐻕iŎgp
ꍇAi̕ɎӎĂ΍KłAK{ł͂܂B
\[XύXꍇ́ÂƂ𖾎Ȃ΂Ȃ܂BIWĩ\tgE
FAłƂU̕\Ă͂Ȃ܂B
\[X̔ЕzA̕\폜A\̓eύX肵Ă͂Ȃ܂
B 

project site : https://sourceforge.jp/projects/gslib/
my site : http://www.game-syokunin.com/
*/

#include <gslib/static_container/hash.h>
#include <gslib/static_container/list.h>

namespace gslib {
	namespace static_container {
		///	hash ƁAlist gݍ킹WnbV
		template < typename Key, typename Value, size_t MaxSize, typename KeyEqual = std::equal_to< Key > >
		class list_hash : public hash< Key, Value, list< std::pair< Key, Value >, MaxSize >, KeyEqual > {
		public:
			typedef hash< Key, Value, list< std::pair< Key, Value >, MaxSize >, KeyEqual >	parent;
			
			typedef typename parent::value_type			value_type;
			typedef typename parent::reference			reference;
			typedef typename parent::const_reference	const_reference;
			typedef typename parent::iterator			iterator;
			typedef typename parent::const_iterator		const_iterator;
			typedef typename parent::size_type			size_type;

			list_hash( key_equal equal = KeyEqual() ) : parent( equal ) {}
		};
	}
}

#endif
