#include <gslib/test/assert_new.h>
#define BOOST_AUTO_TEST_MAIN
#include <boost/test/auto_unit_test.hpp>
#include <gslib/static_container/list_hash.h>
#include <string.h>

using namespace gslib;
using namespace static_container;

///	@test static_container::list_hash
BOOST_AUTO_UNIT_TEST( test_int_hash ) {
	test::assert_new::begin(); // new Ăяoɓ{苶I
	typedef list_hash<
		int,
		int,
		10 >	int_hash;
	
	int_hash ihash;
	ihash[ 0 ] = 100;
	ihash[ 5 ] = 20;
	
	BOOST_REQUIRE( 2 == ihash.size() );
	BOOST_REQUIRE( 100 == ihash[ 0 ] );
	BOOST_REQUIRE( 20 == ihash[ 5 ] );
	ihash[ 5 ] = 30;
	BOOST_REQUIRE( 30 == ihash[ 5 ] );
	BOOST_REQUIRE( 2 == ihash.size() );
	test::assert_new::end();
}
