#ifndef STATIC_CONTIANER_TEST_TEST_STRING_H

#define STATIC_CONTIANER_TEST_TEST_STRING_H

#include <gslib/numeric.h>

///	̊{eXg
template < typename StrGen >
void test_string() {
	#define STR( len )	StrGen::gen< len >::type
	{
		STR( 15 ) empt;
		BOOST_CHECK( empt == "" );
		STR( 15 )	str = "hello world";
		BOOST_CHECK( "" != str );
		BOOST_CHECK( "hello world" == str );
		STR( 15 )	str2 = "hello world";
		BOOST_CHECK( str2 == str );
		
		//	ȑeXg
		str2 = str2;
		BOOST_CHECK( str2 == str );
		
		str = "other string";
		BOOST_CHECK( "other string" == str );
		
		STR( 20 ) otherSize( "my size is 20" );
		str = otherSize;
		BOOST_CHECK( str == "my size is 20" );
		STR( 15 ) str3( otherSize );
		BOOST_CHECK( str3 == "my size is 20" );
		
		//	i[s\̐؂̂
		str3 = "aaaaaaaaaaaaaaaaaaaa";
		BOOST_CHECK_MESSAGE( 15 == str3.size(), str3.c_str() );
		BOOST_CHECK( "aaaaaaaaaaaaaaaaaaaa" != str3 );
	}
	{
		STR( 20 ) a( "a" ), b( "b" ), c;
		c += a; c += b;
		BOOST_CHECK( "ab" == c );
		
		a.pop_back();
		BOOST_CHECK( "" == a );
		a.clear();
		BOOST_CHECK( 0 == a.size() );
		b.clear();
		BOOST_CHECK( 0 == b.size() );
		b.append( a );
		BOOST_CHECK( 0 == b.size() );
		b.append( "append" );
		BOOST_CHECK( "append" == b );
		b += "append";
		BOOST_CHECK( "appendappend" == b );
		a += STR( 10 )( "abc" );
		BOOST_CHECK( "abc" == a );
	}
	#undef STR
}

#endif