#include <gslib/test/assert_new.h>
#define BOOST_AUTO_TEST_MAIN
#include <boost/test/auto_unit_test.hpp>
#include <gslib/static_container/vector.h>
#include "basic_sequence.h"
#include "dump.h"

using namespace gslib;
using namespace static_container;

struct vectorgen {
	template < typename Value, size_t Size >
	struct gen {
		typedef vector< Value, Size >	type;
	};
};

///	@test static_container::vector
BOOST_AUTO_UNIT_TEST( test_vector_basic ) {
	test::assert_new::begin(); // new Ăяoɓ{苶I
	basic_sequence< vectorgen >();
	dump< vectorgen >();
	test::assert_new::end();
}

